Subject: bug#41955: 28.0.50; Monorepos and project.el

From: Eli Zaretskii <[email-masked]>
Date: Sat, 20 Jun 2020 10:17:12 +0300

> Date: Fri, 19 Jun 2020 20:42:26 +0000
> From: Theodor Thornhill <[email-masked]>
> 
> gigarepo/
> ├── clients
> │   ├── client1
> │   ├── client2
> │   ├── client3
> │   └── client4
> └── services
>     ├── service1
>     ├── service2
>     ├── service3
>     └── service4
> 
> The services are made in different languages, say, some in c#, f#, java -
> as are clients, some are Typescript projects, some are JS etc etc.
> 
> Everything is rooted in a ".git" in "gigarepo/", and there are no
> submodules or any fancyness.
> 
> As project.el works now, there are several issues arising. I'll just
> note them down here, and probably split things up later, if that is ok.
> 
> * Lsp server/client
>   In most of the projects, the lsp servers are indexing from what they
>   consider root. Typically a tsconfig.json, elm.json etc. They get
>   confused, eglot a bit more than lsp-mode (it has its own root finding
>   algorithm). What happens is they look in root (gigarepo/), and it has
>   no executable for lsp-server. One solution is then to install the
>   server in root, but then it indexes the whole thing, and gets super
>   slow, and indexes a lot of unrelated stuff (I'm not even working on
>   client 2-4.)
>   
> * Buffer switching
>   Lets say several of the clients uses a module called AuthService.ts.
>   If I'm working on several of these projects you get a lot of identical
>   files, so it is a bit hit and miss.
>   
> * Grepping
>   This one was the worst for me, since grepping was very slow given the
>   size of the project, and grepping loads of unrelated files returns a
>   lot of noise. 
> 
> 
> What would be nice is to be able to get the benefits of the vc-dir
> version of project.el, but not having to "git init" inside the child
> projects. More specifically, to be able to choose "project context",
> one as the closest project-root and one as the gigarepo project-root.

Would it help to have facilities of specifying the files in a project
by starting with an empty project, and then adding the files one by
one?  Also, to be able to say that all the files in a given directory
(optionally, only files that match some shell wildcard), recursively,
should be added to a project?

This would probably need a way of making the list of files/directories
in a project persistent between sessions, because currently we rely on
the filesystem or a VCS to record that.